
// April 2015 code too large for Uno.
// String Variable corrupts. around 20MB
// Uno heap area too small. Using 2560.
// Added Temp sensor to Web server
// Future: Add SMTP funtion to alert on Temp
// Future: Add Pin alert for SMTP - Could use PIR


#include <SPI.h>
#include <Ethernet.h>
#include <EEPROM.h>
#include <avr/wdt.h>
#include <dht.h>
#define DHT22_PIN 2


int Port1 = 8; 
int Port2 = 9; 
int State1;
int State2;
int myForm = 1;
int setmode = 0;
int IPset = 0;
int port = 80;
String Port;
char c;
boolean Statechange;
String readString; 
byte dhcp = 1;
int password;
String Password;
unsigned long adminpass;
String AdminPass;
byte tempadd[4];
int  SecureOK = 0;
String Title;
String Relay1;
String Relay2;
int titlepos = 20;
int relay1pos = 40;
int relay2pos = 50;
int adminpasspos = 60;
int passpos = 18;
int portpos = 63;

byte mac[] = { 
  0xDE, 0xAD, 0xBE, 0xEF, 0xFE, 0xED }; //physical mac address
byte ip[] = { 
  192, 168, 2, 10 }; // ip in lan
byte dns1[] = { 
  192, 168, 2, 1 }; // ip in lan
byte gateway[] = { 
  192, 168, 2, 1 }; // internet access via router
byte subnet[] = { 
  255, 255, 255, 0 }; //subnet mask
byte smtp[] = { 
  0, 0, 0, 0 }; //smtp server

dht DHT;
EthernetServer server(EEPROM.read(portpos)*100+EEPROM.read(portpos+1)); //server port
EthernetClient client;

void setup()
{
  pinMode(Port1, OUTPUT);  // Relay 1
  pinMode(Port2, OUTPUT);  // Relay 2
  GetValues();  //Load Eeprom stored vaules
  if (dhcp==1) //Stored IP mode
  {
    if (Ethernet.begin(mac) == 0) //If DHCP fails set manual address
    {
      Ethernet.begin(mac, ip, dns1, gateway, subnet);
    }
  }
  else  // Stored Static Mode

  {
    Ethernet.begin(mac, ip, dns1, gateway, subnet);
  }
  server.begin();
  State1 = 1;
  State2 = 0;
  SetRelays();
  Statechange = false;
}



void loop()
{
  // listen for incoming clients
  client = server.available();
  if (client) 
  {
    while (client.connected()) 
    {
      if (client.available()) 
      {
        char c = client.read();
        if (readString.length() < 130)
        {
          readString += c; 
        } 
        if (c == '\n') 
        {
          PrintHead();
          GetAction();
          SetRelays();
          break;
        }
      }
    }
    // give the web browser time to receive the data
    delay(1);
    // close the connection:
    client.stop();
    readString = "";
  }
}

void GetAction()
{  //Commands at the start don't require the password check. Already passed
 if(myForm==2)  // If Form at 2 assume password was OK to get there. Accept high order commands
 {
  if(readString.indexOf("INIT1=Yes") >0)
  { 
    client.stop();
    Reboot();
  }
  if(readString.indexOf("INIT") >0) //Initialize values
  {
    client.println("<FORM ACTION='/' method=get >"); 
    client.println("Initialise: Are you sure?<br>");
    client.println("<INPUT TYPE=SUBMIT NAME='Init' VALUE='Yes'>");
    client.println("<INPUT TYPE=SUBMIT NAME='Init' VALUE='No'>");
    client.println("</FORM>");
    delay(2);
    ClearNewForm();
  }
  if(readString.indexOf("Init=Yes") >0) //Initialize values
  {
    myForm = 0;
    setmode = 0;
    Initialize();
    ClearNewForm();
    client.println("Rebooting Server - Please wait 30 sec before refresh");
    Reboot();
  }
  if(readString.indexOf("Init=No") >0) //Initialize values
  {
    myForm = 1;
    setmode = 0;
    ClearNewForm();
  }
  if (myForm==2)
  {
    if(readString.indexOf("sDHSave=Set+DHCP") >0) //commit
    {
      myForm = 2;
      setmode = 0;
      dhcp = 1;
      Savedhcp();
      ClearNewForm();
    }
    if(readString.indexOf("sDHSave=Set+Static") >0) //commit
      {
        myForm = 2;
        setmode = 0;
        dhcp = 0;
        Savedhcp();
        ClearNewForm();
      }
    if(readString.indexOf("title=") >0) //modify title
    {
      if(readString.indexOf("Tcommit=Save") >0) //save
      {
        Title = readString.substring(readString.indexOf("title=")+6,readString.indexOf("Tcommit")-1);
        Title = RemoveFormat(Title);
        Savetext(Title,titlepos);
        ClearNewForm();
      }
    }
    if(readString.indexOf("relay1=") >0) //modify title
    {
      if(readString.indexOf("R1commit=Save") >0) //save
      {
        Relay1 = readString.substring(readString.indexOf("relay1=")+7,readString.indexOf("R1commit")-1);
        Relay1 = RemoveFormat(Relay1);
        Savetext(Relay1,relay1pos);
        ClearNewForm();
      }
    }
    if(readString.indexOf("relay2=") >0) //modify title
    {
      if(readString.indexOf("R2commit=Save") >0) //save
      {
        Relay2 = readString.substring(readString.indexOf("relay2=")+7,readString.indexOf("R2commit")-1);
        Relay2 = RemoveFormat(Relay2);
        Savetext(Relay2,relay2pos); 
        ClearNewForm();
      }
    }
    if(readString.indexOf("port=") >0) //modify port
    {
      if(readString.indexOf("Pcommit=Save") >0) //save
      {
          String TPort = readString.substring(readString.indexOf("port=")+5,readString.indexOf("port=")+9);
          int porttest = TPort.toInt();
          if (porttest > 32766)  // reject port too large
          {
            client.println("Port rejected - Too large");
          }
          else
          {
            if (porttest < 1)  // reject port too small
            {
              client.println("Port rejected - Too small");
            }
            else
            {
              Port = TPort;
              port = porttest;
              Saveport();
              client.println("NOTE: Reboot required to take effect");
              delay(2);
              ClearNewForm();
            }
          }
      }
    }

    if(readString.indexOf("pwd=") >0) //modify password
    {
      if(readString.indexOf("Save=Save") >0) //save
      {
        if (readString.indexOf("pwd=")+8 == readString.indexOf("&",readString.indexOf("pwd")))
        {
          Password = readString.substring(readString.indexOf("pwd=")+4,readString.indexOf("pwd=")+8);
          int passwordtest = Password.toInt();
          if (passwordtest > 999)
          {
            passwordtest = Password.toInt();
            myForm = 2;
            Savepass();
            setmode = 0;
            IPset = 0;
          }
          else
          {
            client.println("Password cannot contain leading zeros - Password rejected");
          }
        }
        else
        {
          client.println("Password must be 4 numerics long. - Password rejected");
        }
       ClearNewForm();
       delay(5000);       
       client.println("Rebooting Server - Please wait 30 sec before refresh");
       Reboot();
      }
    }
    if(readString.indexOf("adminpwd=") >0) //modify password
    {
      if(readString.indexOf("SaveAdmin=Save") >0) //save
      {
        if (readString.indexOf("adminpwd=")+15 == readString.indexOf("&",readString.indexOf("adminpwd")))
        {
          // get first 4
          AdminPass = readString.substring(readString.indexOf("adminpwd=")+9,readString.indexOf("adminpwd=")+13);
          unsigned long passwordtest = AdminPass.toInt()*100; // convert
          // get last 2
          AdminPass = readString.substring(readString.indexOf("adminpwd=")+13,readString.indexOf("adminpwd=")+15);
          passwordtest = passwordtest + AdminPass.toInt();
          AdminPass = readString.substring(readString.indexOf("adminpwd=")+9,readString.indexOf("adminpwd=")+15);
          if (passwordtest > 99999)
          {
            adminpass = passwordtest;
            myForm = 2;
            Saveadminpass();
            setmode = 0;
            IPset = 0;
            client.println("Rebooting Server - Please wait 30 sec before refresh");
            delay(5000);       
            Reboot();
          }
          else
          {
            client.println("Password cannot contain leading zeros - Password rejected");
          }
        }
        else
        {
          client.println("Password must be 6 numerics long. - Password rejected");
        }
       ClearNewForm();
      }
    }
    if(readString.indexOf("REBOOT") >0) //Reboot
    {
      ClearNewForm();
      delay(5000);       
      Delayreload(10);
      Reboot();
    }
    if(readString.indexOf("sB") >0)  //return
    {
      myForm = 1;
      SecureOK = 0;
      setmode = 0;
      ClearNewForm();
    }
    if(readString.indexOf("sC=Mask") >0)  //subnet mask
    {
      myForm = 2;
      IPset = 1;
      setmode = 1;
      Loadaddress();
      ClearNewForm();
    }
    if(readString.indexOf("sC=IP") >0)  //ip address
    {
      myForm = 2;
      IPset = 0;
      setmode = 1;
      Loadaddress();
      ClearNewForm();
    }
    if(readString.indexOf("sC=Gateway") >0)  //gateway
    {
      myForm = 2;
      IPset = 2;
      setmode = 1;
      Loadaddress();
      ClearNewForm();
    }
    if(readString.indexOf("sC=Smtp") >0)  //gateway
    {
      myForm = 2;
      IPset = 3;
      setmode = 1;
      Loadaddress();
      ClearNewForm();
    }
    if(readString.indexOf("storeip=Commit") >0)  //commit ip values
    {
      myForm = 2;
      setmode = 1;
      Assignip();
      Saveip();
      ClearNewForm();
    }
  }
 }  //End raised security
  if(readString.indexOf(Password) > 0)  //All other commands available if the password is correct
  {
    SecureOK = 1;
    if(readString.indexOf("s1") >0)
    {
      client.print("Power on ");
      client.print(Relay1);
      client.println("<BR>");
      State1 = 1;
      Statechange = true;
      ClearNewForm();
    }
    if(readString.indexOf("s4") >0)
    {
      client.print("Power on ");
      client.print(Relay2);
      client.println("<BR>");
      State2 = 1;
      Statechange = true;
      ClearNewForm();
    }
    if(readString.indexOf("s2") >0)
    {
      client.print("Power off ");
      client.print(Relay1);
      client.println("<BR>");
      State1 = 0;
      Statechange = true;
      ClearNewForm();
    }
    if(readString.indexOf("s5") >0)
    {
      client.print("Power off ");
      client.print(Relay2);
      client.println("<BR>");
      State2 = 0;
      Statechange = true;
      ClearNewForm();
    }
    if(readString.indexOf("s3") >0)
    {
      client.print("Power off ");
      client.print(Relay1);
      client.println("<BR>");
      State1 = 0;
      Statechange = true;
      SetRelays();
      delay(5000);
      client.print("Power on ");
      client.print(Relay1);
      client.println("<BR>");
      Statechange = true;
      State1 = 1;
      ClearNewForm();
    }
    if(readString.indexOf("s6") >0)
    {
      client.print("Power off ");
      client.print(Relay2);
      client.println("<BR>");
      State2 = 0;
      Statechange = true;
      SetRelays();
      delay(5000);
      client.print("Power on ");
      client.print(Relay2);
      client.println("<BR>");
      Statechange = true;
      State2 = 1;
      ClearNewForm();
    }
  }
  if(readString.indexOf(AdminPass) > 0)  //All other commands available if the password is correct
  {
    if(readString.indexOf("s8") >0)  // Sets Settings Form to load 
    {
      client.println("Entering Settings<BR>");
      delay(1000);
      myForm = 2;
      setmode = 0;      
      ClearNewForm();
    }
  }
}

void PrintHead()
{
  client.println("HTTP/1.1 200 OK");
  client.println("Content-Type: text/html");
  client.println();
  client.println("<!DOCTYPE HTML>");
  client.println("<HTML>");
  client.println("<HEAD>");
  client.println("<script type=\"text/javascript\">");
  client.println("   function reloadpage() {");
  client.print("  window.location = ");
  client.print("\"http://");
  client.print(Ethernet.localIP());
  client.print(":");
  client.print(port);
  client.println("\";");
  client.println("}");
  client.println("</script>");
  client.println("<TITLE>Relay Server</TITLE>");
//  Delayreload(30);
  client.println("</HEAD>");
  client.println("<BODY>");
  if (myForm == 1)
  {
    client.print("<H2>");
    client.print(Title);
    client.println("</H2>");
    PrintTemp();
    client.println("<FORM ACTION='/' method=get >"); 
    client.println("Password: <INPUT TYPE=TEXT NAME='PASS' VALUE='' SIZE='25' MAXLENGTH='50'><BR>");
    client.print("<INPUT TYPE=SUBMIT NAME='s1' VALUE='");
    client.print(Relay1);
    client.print(" On'>");
    client.print("<INPUT TYPE=SUBMIT NAME='s2' VALUE='");
    client.print(Relay1);
    client.print(" Off' >");
    client.print("<INPUT TYPE=SUBMIT NAME='s3' VALUE='");
    client.print(Relay1);
    client.println(" Reset'>");
    client.println("<BR>");
    client.print("<INPUT TYPE=SUBMIT NAME='s4' VALUE='");
    client.print(Relay2);
    client.print(" On'>");
    client.print("<INPUT TYPE=SUBMIT NAME='s5' VALUE='");
    client.print(Relay2);
    client.print(" Off'>");
    client.print("<INPUT TYPE=SUBMIT NAME='s6' VALUE='");
    client.print(Relay2);
    client.println(" Reset'>");
    client.println("<BR>");
    client.println("<INPUT TYPE=\"button\" NAME='s9' VALUE='Reload Page' onclick=\"reloadpage();\" >");
    client.println("<INPUT TYPE=SUBMIT NAME='s8' VALUE='Settings'>");
    client.println("<BR>");
    client.println("<BR>");
    client.println("Current State: ");   //At completion of a page Show current relay values
    if (State1 == 0) 
    {
      client.print(Relay1); 
      client.println(" = Off. "); 
    }
    else
    {
      client.print(Relay1); 
      client.println(" = On. "); 
    }
    if (State2 == 0) 
    {
      client.print(Relay2); 
      client.println(" = Off. "); 
    }
    else
    {
      client.print(Relay2); 
      client.println("  = On. "); 
    }
  } 
  else  //Setup Page Body goes here
  {
    client.print("<H2>");
    client.print(Title);
    client.println("</H2>");
    client.println("<H2>Settings Page</H2>");
    client.println("<BR>");
    PrintTemp();
    client.print("IP mode = ");
    if (dhcp == 1) 
    {
      client.print("DHCP:  ");
    } 
    else
    { 
      client.print("Static:  ");
    } 
    client.print("Current IP address = ");
    client.print(Ethernet.localIP());
    client.println("<BR>");
    PrintIP(1);  //Display Current IP values
    client.println("<FORM ACTION='/' method=get >"); 
    client.println("Project Title = ");
    client.print("<INPUT TYPE=TEXT NAME='title' VALUE='");
    client.print("' SIZE='20' MAXLENGTH='20'>");
    client.println("<INPUT TYPE=SUBMIT NAME='Tcommit' VALUE='Save'>");
    client.println("<BR>");
    client.println("Relay 1 Name = ");
    client.print("<INPUT TYPE=TEXT NAME='relay1' VALUE='");
    client.print("' SIZE='10' MAXLENGTH='10'>");
    client.println("<INPUT TYPE=SUBMIT NAME='R1commit' VALUE='Save'>");
    client.println("<BR>");
    client.println("Relay 2 Name = ");
    client.print("<INPUT TYPE=TEXT NAME='relay2' VALUE='");
    client.print("' SIZE='10' MAXLENGTH='10'>");
    client.println("<INPUT TYPE=SUBMIT NAME='R2commit' VALUE='Save'>");
    client.println("<BR>");
    client.println("New Control Password(4 num only) = ");
    client.print("<INPUT TYPE=TEXT NAME='pwd' VALUE='' SIZE='4' MAXLENGTH='4'>");
    client.println("<INPUT TYPE=SUBMIT NAME='Save' VALUE='Save'>");
    client.println("<BR>");
    client.println("New Admin Password(6 num only) = ");
    client.print("<INPUT TYPE=TEXT NAME='adminpwd' VALUE='' SIZE='6' MAXLENGTH='6'>");
    client.println("<INPUT TYPE=SUBMIT NAME='SaveAdmin' VALUE='Save'>");
    client.println("<BR>");
    client.println("TCP/IP Port = ");
    client.print("<INPUT TYPE=TEXT NAME='port' VALUE='' SIZE='4' MAXLENGTH='4'>");
    client.println("<INPUT TYPE=SUBMIT NAME='Pcommit' VALUE='Save'>");
    client.println("<BR>");
    client.println("Address mode: ");
    client.print("<INPUT TYPE=SUBMIT NAME='sDHSave' VALUE='Set DHCP'>");  // Commit dhcp values
    client.println("<INPUT TYPE=SUBMIT NAME='sDHSave' VALUE='Set Static'>");  // Commit dhcp values
    client.println("<BR>");
    client.println("Load and Set ");
    client.println("<BR>");
    client.println("<INPUT TYPE=SUBMIT NAME='sC' VALUE='IP'>");  // Buttons used to load input form with current values.
    client.println("<INPUT TYPE=SUBMIT NAME='sC' VALUE='Mask'>");
    client.println("<INPUT TYPE=SUBMIT NAME='sC' VALUE='Gateway'>");
    client.println("<INPUT TYPE=SUBMIT NAME='sC' VALUE='Smtp'>");
    client.println("<BR>");
    if (setmode == 1)
    {
      if (IPset == 0) 
      {
        client.println("IP address = "); 
      }
      if (IPset == 1) 
      {
        client.println("Subnet Mask = "); 
      }
      if (IPset == 2) 
      { 
        client.println("Gateway = "); 
      }
      if (IPset == 3) 
      { 
        client.println("SMTP = "); 
      }
      //Input forms for 4 octects here
      client.print("<INPUT TYPE=TEXT NAME='Add1' VALUE='");
      client.print(String(tempadd[0]));
      client.println("' SIZE='3' MAXLENGTH='3'>");
      client.print("<INPUT TYPE=TEXT NAME='Add2' VALUE='");
      client.print(String(tempadd[1]));
      client.println("' SIZE='3' MAXLENGTH='3'>");
      client.print("<INPUT TYPE=TEXT NAME='Add3' VALUE='");
      client.print(String(tempadd[2]));
      client.println("' SIZE='3' MAXLENGTH='3'>");
      client.print("<INPUT TYPE=TEXT NAME='Add4' VALUE='");
      client.print(String(tempadd[3]));
      client.println("' SIZE='3' MAXLENGTH='3'>");
      client.println("<INPUT TYPE=SUBMIT NAME='storeip' VALUE='Commit'>");
   }
    client.println("<BR>");
    client.println("<INPUT TYPE=\"button\" NAME='s9' VALUE='Reload Page' onclick=\"reloadpage();\" >");
    client.println("<INPUT TYPE=SUBMIT NAME='sB' VALUE='Return to Home'>");
    client.println("<INPUT TYPE=SUBMIT NAME='REBOOT' VALUE='Reboot Server'>");
    client.println("<INPUT TYPE=SUBMIT NAME='INIT' VALUE='Initialise'>");
    client.println("<BR>");
  }
  client.println("<BR>");
  client.println("</FORM>");
  client.println("<BR>");
  client.println("</BODY>");
  client.println("</HTML>");
      
}

void PrintTemp()
{
 int chk = DHT.read22(DHT22_PIN);
  switch (chk)
  {
    case DHTLIB_OK:  
//		  client.print("Temp: OK,\t"); 
		break;
    case DHTLIB_ERROR_CHECKSUM: 
		  client.print("Temp: Checksum error,\t"); 
		break;
    case DHTLIB_ERROR_TIMEOUT: 
		  client.print("Temp: Time out error,\t"); 
		break;
    default: 
		  client.print("Temp: Unknown error,\t"); 
		break;
  }
    client.print("Enviro - Temp = ");
    client.print(DHT.temperature,1);
    client.print("C, Rel Humidity = \t");
    client.print(DHT.humidity,1);
    client.print("% ,\t");
    client.println("<BR>");
}

void PrintIP(int displaymode)
{
  if (displaymode==1)
  {
    client.print("Saved IP address = ");
  }
  client.print(ip[0]);
  client.print(".");
  client.print(ip[1]);
  client.print(".");
  client.print(ip[2]);
  client.print(".");
  client.print(ip[3]);
  if (displaymode==1)
  {
    client.println("<BR>");
    client.print("TCPIP Port = ");
    client.print(port);
    client.println("<BR>");
    client.print("Subnet Mask = ");
    client.print(subnet[0]);
    client.print(".");
    client.print(subnet[1]);
    client.print(".");
    client.print(subnet[2]);
    client.print(".");
    client.print(subnet[3]);
    client.println("<BR>");
    client.print("Gateway = ");
    client.print(gateway[0]);
    client.print(".");
    client.print(gateway[1]);
    client.print(".");
    client.print(gateway[2]);
    client.print(".");
    client.print(gateway[3]);
    client.println("<BR>");
    client.print("Smtp Server = ");
    client.print(smtp[0]);
    client.print(".");
    client.print(smtp[1]);
    client.print(".");
    client.print(smtp[2]);
    client.print(".");
    client.print(smtp[3]);
    client.println("<BR>");
    client.print("Control Password = ");
    client.print(Password);  //Display old password
    client.print("   Admin Password = ");
    client.print(AdminPass);  //Display old password
    client.println("<BR>");
  }
}

void Delayreload(int delaysec)
{
  client.print("<meta http-equiv=\"refresh\" content=\"");
  client.print(delaysec);
  client.print(";URL=http://");
  PrintIP(0);
  client.print(":");
  client.print(port);
  client.println("\"/>");
}

void ClearNewForm()
{
  client.println("<script>");
  client.println("  reloadpage();");
  client.println("</script>");
}

void Loadaddress()
{
  if (IPset == 0)
  {
    for (int x = 0; x < 4; x++)
    {
      tempadd[x] = ip[x];
    }
  }
  if (IPset == 1)
  {
    for (int x = 0; x < 4; x++)
    {
      tempadd[x] = subnet[x];
    }
  }
  if (IPset == 2)
  {
    for (int x = 0; x < 4; x++)
    {
      tempadd[x] = gateway[x];
    }
  }
  if (IPset == 3)
  {
    for (int x = 0; x < 4; x++)
    {
      tempadd[x] = smtp[x];
    }
  }
}

void Saveaddress()
{
  if (IPset == 0)
  {
    for (int x = 0; x < 4; x++)
    {
      ip[x] = tempadd[x];
    }
  }
  if (IPset == 1)
  {
    for (int x = 0; x < 4; x++)
    {
      subnet[x] = tempadd[x];
    }
  }
  if (IPset == 2)
  {
    for (int x = 0; x < 4; x++)
    {
      gateway[x] = tempadd[x];
    }
  }
}

int Getaddress(String Instring, String Address)
{
  int Result;
  String address;
  if(Instring.indexOf(Address) <= 0)
  { 
    Result = 256;
  } 
  else
  {
    address = (Instring.substring(Instring.indexOf(Address)+5,Instring.indexOf("&",Instring.indexOf(Address))));
    Result = address.toInt();
  }  
  return Result;
}

void Assignip()
{
  byte TempAdd[4];
  TempAdd[0] = Getaddress(readString, "Add1=");
  TempAdd[1] = Getaddress(readString, "Add2=");
  TempAdd[2] = Getaddress(readString, "Add3=");
  TempAdd[3] = Getaddress(readString, "Add4=");
  if (IPset == 0) 
  {
    for (int x=0; x < 4; x++)
    {
      ip[x] = TempAdd[x];
    }
  }
  if (IPset == 1) 
  {
    for (int x=0; x < 4; x++)
    {
      subnet[x] = TempAdd[x];
    }
  }
  if (IPset == 2) 
  {
    for (int x=0; x < 4; x++)
    {
      gateway[x] = TempAdd[x];
    }
  }
  if (IPset == 3) 
  {
    for (int x=0; x < 4; x++)
    {
      smtp[x] = TempAdd[x];
    }
  }
}

void SaveValues()
{
  // Must save data format as GetValues
  // address 0 is set to 1 if data is valid otherwise values are initialized
  // byte 1 is 1 = dhcp or 0 = static address NOTE default is on
  // first 4 bytes are ip address
  // next 4 are subnet
  // next 4 are gateway
  // next 2 are password NOTE default = 1234
  // Future:
  //        SMTP PO address
  //        SMTP Sender
  //        SMTP recipient
  //        SMTP Alerts PIR / Temp
  //        GPRS option board for SMS alert
  //        GPRS Alerts PIR / Temp
  //        SMS phone number
  int addr = 0;
  byte val;
  EEPROM.write(addr, 1); // Valid Data
  Savedhcp();
  Saveip();
  Savepass();
  Savetext(Title,titlepos);
  Savetext(Relay1,relay1pos);
  Savetext(Relay2,relay2pos); 
  Saveadminpass();
  Saveport();
}

void Savetext(String instring1,int add1)
{
  char charBuf[20];
  instring1.toCharArray(charBuf, 20); 
  int position = add1;
  for (int x=0; x < instring1.length(); x++)
  {
    EEPROM.write(position++,charBuf[x]);
  }
  EEPROM.write(position,'\0');  // Save the NULL terminator
}

String Gettext(int add1)
{
  char p;
  String intext = "";
  int pos1 = add1; 
  for(int x=0;x < add1; x++)
  {
    p = EEPROM.read(pos1++);
    if (p != '\0')
    {
      intext += p;
    }
    else
    {
      break;
    }
  }
  return intext;
}

void Saveip()
{
  int addr = 0;
  byte val;
  addr++;
  addr++;
  if (setmode != 0)
  {
    EEPROM.write(addr,ip[0]);
    addr++;
    EEPROM.write(addr,ip[1]);
    addr++;
    EEPROM.write(addr,ip[2]);
    addr++;
    EEPROM.write(addr,ip[3]);
    addr++;
    EEPROM.write(addr,subnet[0]);
    addr++;
    EEPROM.write(addr,subnet[1]);
    addr++;
    EEPROM.write(addr,subnet[2]);
    addr++;
    EEPROM.write(addr,subnet[3]);
    addr++;
    EEPROM.write(addr,gateway[0]);
    addr++;
    EEPROM.write(addr,gateway[1]);
    addr++;
    EEPROM.write(addr,gateway[2]);
    addr++;
    EEPROM.write(addr,gateway[3]);
    addr++;
    EEPROM.write(addr,smtp[0]);
    addr++;
    EEPROM.write(addr,smtp[1]);
    addr++;
    EEPROM.write(addr,smtp[2]);
    addr++;
    EEPROM.write(addr,smtp[3]);
  }
}

void Savepass()
{
  int addr = 0;
  byte val;
  EEPROM.write(addr, 1); // Valid Data
  addr = passpos+1;
  int X = Password.toInt();  //Need to break password up in 2 dec bytes
  int digit4 = (X / 1000);
  int digit3 = ((X / 100)-(digit4 * 10));
  int digit2 = ((X % 100) / 10);
  int digit1 = (X % 10);
  byte pass1 = ((digit2*10)+digit1);
  EEPROM.write(addr,pass1);
  addr = passpos;
  pass1 = ((digit4*10)+digit3);
  EEPROM.write(addr,pass1);
}

void Saveadminpass()
{
  int addr = 0;
  byte val;
  unsigned long X;
  EEPROM.write(addr, 1); // Valid Data
  addr = adminpasspos+2;
  String AdminPass1;
  // get first 4
  AdminPass1 = AdminPass.substring(0,4);
  unsigned long passwordtest = AdminPass1.toInt()*100; // convert
  // get last 2
  AdminPass1 = AdminPass.substring(4,6);
  X = passwordtest + AdminPass1.toInt();
  unsigned long digit6= (X / 100000);
  unsigned long digit5 = ((X / 10000)-(digit6 * 10));
  int digit4 = ((X % 10000)/1000);
  int digit3 = ((X % 1000)/100);
  int digit2 = ((X % 100) / 10);
  int digit1 = (X % 10);
  byte pass1 = ((digit2*10)+digit1);
  EEPROM.write(adminpasspos+2,pass1);
  pass1 = ((digit4*10)+digit3);
  EEPROM.write(adminpasspos+1,pass1);
  pass1 = ((digit6*10)+digit5);
  EEPROM.write(adminpasspos,pass1);
}

void Savedhcp()
{
  int addr = 0;
  byte val;
  EEPROM.write(addr, 1); // Valid Data
  addr++;
  EEPROM.write(addr, dhcp);
  addr++;
}

void Saveport()
{
  int X = port;
  int digit4 = (X / 1000);
  int digit3 = ((X / 100)-(digit4 * 10));
  int digit2 = ((X % 100) / 10);
  int digit1 = (X % 10);
  byte pass1 = ((digit2*10)+digit1);
  EEPROM.write(portpos+1,pass1);
  pass1 = ((digit4*10)+digit3);
  EEPROM.write(portpos,pass1);
}

void Getport()
{
  port = EEPROM.read(portpos)*100+EEPROM.read(portpos+1);
  // If port is less than 0 or greater than 32000 port will be 80
  if (port < 1)
  {
    port = 80;
  }
  if (port > 32766)
  { 
    port = 80; 
  }
}

void GetValues()
{
  // address 0 is set to 1 if data is valid otherwise values are initialized
  // byte 1 is 1 = dhcp or 0 = static address NOTE default is on
  // first 4 bytes are ip address
  // next 4 are subnet
  // next 4 are gateway
  // next 4 are smtp server
  // next 2 are password NOTE default = 1234
  // 20..39 are Title
  // 40..49 are Relay1 name
  // 50..59 are Relay2 name
  // 60..62 are adminpass
  // 63..64 are port
  int addr = 0;
  byte val;
  unsigned long templong;
  val = EEPROM.read(addr);
  if (val != 1) 
  {
    Initialize();
  }
  addr++;
  dhcp = EEPROM.read(addr);
  addr++;
  ip[0] = EEPROM.read(addr);
  addr++;
  ip[1] = EEPROM.read(addr);
  addr++;
  ip[2] = EEPROM.read(addr);
  addr++;
  ip[3] = EEPROM.read(addr);
  addr++;
  subnet[0] = EEPROM.read(addr);
  addr++;
  subnet[1] = EEPROM.read(addr);
  addr++;
  subnet[2] = EEPROM.read(addr);
  addr++;
  subnet[3] = EEPROM.read(addr);
  addr++;
  gateway[0] = EEPROM.read(addr);
  addr++;
  gateway[1] = EEPROM.read(addr);
  addr++;
  gateway[2] = EEPROM.read(addr);
  addr++;
  gateway[3] = EEPROM.read(addr);
  addr++;
  smtp[0] = EEPROM.read(addr);
  addr++;
  smtp[1] = EEPROM.read(addr);
  addr++;
  smtp[2] = EEPROM.read(addr);
  addr++;
  smtp[3] = EEPROM.read(addr);
  addr = passpos;
  password = EEPROM.read(addr);
  //password is assumed to be 4 digit, numeric, no leading 0s, Stored as 2 bytes BDCD
  password = password * 100;
  addr = passpos+1;
  val = EEPROM.read(addr);
  password = password + val;
  Password = String(password);
  Title = Gettext(titlepos);
  Relay1 = Gettext(relay1pos);
  Relay2 = Gettext(relay2pos);
  addr = adminpasspos;
  adminpass = EEPROM.read(addr);
  //password is assumed to be 6 digit, numeric, no leading 0s, Stored as 2 bytes BDCD
  adminpass = adminpass * 10000;
  addr++;
  val = EEPROM.read(addr);
  templong = val;
  templong = templong * 100;
  adminpass = adminpass + templong;
  addr++;
  val = EEPROM.read(addr);
  adminpass = adminpass + val;
  AdminPass = String(adminpass);
  Getport();
}

void Initialize()
{
  //Set initial value of Ether address to DHCP
  int addr  = 0;

  EEPROM.write(addr, 1);  //set valid data
  addr++;
  EEPROM.write(addr, 1);  //set dhcp mode
  addr++;
  EEPROM.write(addr, 192);  //set default ip
  addr++;
  EEPROM.write(addr, 168);  
  addr++;
  EEPROM.write(addr, 2); 
  addr++;
  EEPROM.write(addr, 10);  
  addr++;
  EEPROM.write(addr, 255);  //set default SN Mask
  addr++;
  EEPROM.write(addr, 255);  
  addr++;
  EEPROM.write(addr, 255);  
  addr++;
  EEPROM.write(addr, 0);  
  addr++;
  EEPROM.write(addr, 192);  //set gateway
  addr++;
  EEPROM.write(addr, 168);  
  addr++;
  EEPROM.write(addr, 2);  
  addr++;
  EEPROM.write(addr, 1);  
  addr++;
  EEPROM.write(addr, 0);  //set gateway
  addr++;
  EEPROM.write(addr, 0);  
  addr++;
  EEPROM.write(addr, 0);  
  addr++;
  EEPROM.write(addr, 0);  
  addr = passpos; //set address to password byte 1
  EEPROM.write(addr, 12);  //set dhcp mode
  addr = passpos+1; //set address to password byte 1
  EEPROM.write(addr, 34);  //set dhcp mode
  //Title (20), Relay1 (10), Relay2 (10)
  Title = "Relay Server";
  Relay1 = "Relay 1";
  Relay2 = "Relay 2";
  Savetext(Title,titlepos);
  Savetext(Relay1,relay1pos);
  Savetext(Relay2,relay2pos);
  addr = adminpasspos; //set address to password byte 1
  EEPROM.write(addr, 31);  //admin paas 1
  addr++; //set address to password byte 1
  EEPROM.write(addr, 41);  //admin pass 2
  addr++; //set address to password byte 1
  EEPROM.write(addr, 59);  //admin pass 3
  // Write port
  port = 80;
  Saveport();
}


void SetRelays()
{
  if(State1 == 1)
  {
    digitalWrite(Port1, LOW);    // set pin 5 high
  }
  if(State2==1)//checks for on
  {
    digitalWrite(Port2, LOW);    // set pin 5 high
  }
  if(State1==0)//checks for off
  {
    digitalWrite(Port1, HIGH); // set pin 5 low
  }
  if(State2==0)//checks for off
  {
    digitalWrite(Port2, HIGH); // set pin 5 low
  }
  delay(2000);
}

String RemoveFormat(String Instring)
{
  Instring.replace("+"," ");
  return  Instring;
}

void Reboot()
{
  // now force reset chip
      wdt_enable(7);  //Enable watchdog timer 2 seconds
      ClearNewForm();
      while (true)
      {
      }   // loop until reboot happens
}



